﻿* Encoding: UTF-8.
*Clustering
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_HIECLU*/vers3***************************************************************************************.
define !KO_hieclu(matrix= !charend('/') /seq= !charend('/') /n= !charend('/') /id= !charend('/') /square= !charend('/') /method= !charend('/') /preclu= !charend('/') /stop= !charend('/') 
              /save= !charend('/') /msave= !charend('/') /sched= !charend('/') /cumul= !charend('/') /root= !charend('/') /print= !charend('/'))
!let !ncl= 1
!if (!head(!stop)='NCLU' !or !head(!stop)='STEP') !then
 !if (!head(!stop)='NCLU') !then !let !ncl= !tail(!stop) !else !let !ncl= !conc('(nrow(m)-',!tail(!stop),')') !ifend
!else
 !if (!head(!stop)='PROP') !then !let !eloopif= !conc('if sched(step,6)/ntot>=',!tail(!stop))
 !else !if (!head(!stop)='IPROP') !then !let !eloopif= !conc('if nclui(step)/nrow(id)>=',!tail(!stop))
 !else !if (!head(!stop)='COEF') !then !let !eloopif= !conc('if sgn*sched(step,3)>=sgn*',!tail(!stop))
 !else !if (!head(!stop)='MAXN') !then !let !eloopif= !conc('if n(j)>=',!tail(!stop))
 !ifend !ifend !ifend !ifend
!ifend
set mxloops 1E6.
matrix.
!let !ok= 1
!if (!n<>!null !and (!method='WAVERAGE' !or !method='MNSSQ' !or !method='MNVAR')) !then !let !ok= 0
-print /title '>ERROR. Specified N is incompatible with methods WAVERAGE, MNSSQ, and MNVAR.'.
!ifend
!if (!n=!null !and !head(!stop)='IPROP') !then !let !ok= 0
-print /title '>ERROR. STOP=IPROP requires subcommand N be specified.'.
!ifend
!if (!stop='ASS1' !or !stop='ASS2' !or !stop='ASS3') !then !let !ass= 1 !else !let !ass= 0 !ifend
!if (!ass !and !preclu=!null) !then !let !ok= 0
-print /title '>ERROR. STOP=ASS1/ASS2/ASS3 requires subcommand PRECLU be specified.'.
!ifend
!if (!msave<>!null !and !stop=!null) !then !let !ok= 0
-print /title '>ERROR. MSAVE requires subcommand STOP be specified.'.
!ifend
!if (!save='ATSTOP' !and !stop=!null) !then !let !ok= 0
-print /title '>ERROR. SAVE=ATSTOP requires subcommand STOP be specified.'.
!ifend
!if (!ok) !then
 !let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
 !if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
 !let !lm= !len(!matr)
 !if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
-comp ok= 1.
-get m /vari= !matr /names= cnam.
 !if (!fcrop) !then
- comp m= m(:,2:ncol(m)).
- comp cnam= cnam(:,2:ncol(cnam)). 
 !ifend
 !if (!lcrop) !then
- comp m= m(:,1:(ncol(m)-1)).
- comp cnam= cnam(:,1:(ncol(cnam)-1)).
 !ifend
-get rnam /var= varname_.
-comp rnam= t(rnam).
 !if (!seq='COL' !or !seq=!null) !then
  !let !seq1= 'cnam' !let !seq2= 'rnam' !let !rind= 'ind2' !let !cind= 'ind1'
 !else
  !let !seq1= 'rnam' !let !seq2= 'cnam' !let !rind= 'ind1' !let !cind= 'ind2'
 !ifend
-do if nrow(m)<>ncol(m).
- comp cmp= 1.
-else if any(rnam<>cnam).
- comp cmp= 1.
-else.
- comp cmp= 0.
- comp ind1= 1:ncol(m).
- comp ind2= 1:ncol(m).
-end if.
-do if cmp.
- comp flag= kroneker(t(!seq1),make(1,ncol(!seq2),1))=kroneker(!seq2,make(ncol(!seq1),1,1)).
- comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
- release flag.
- comp nnz= msum(ind2>0).
- do if nnz<3.
-  print /title '>ERROR. Among input matrix column names and row names there are too few'.
-  print /title '>identical to be able to compile matrix for analysis.' /space= 0.
-  comp ok= 0.
- else.
-  comp ind1= make(1,nnz,0).
-  comp cnt= 0.
-  loop i= 1 to nrow(ind2).
-   do if ind2(i).
-    comp cnt= cnt+1.
-    comp ind1(cnt)= i.
-   end if.
-  end loop.
-  comp ind2= ind2(ind1).
-  comp m= m(!rind,!cind).
-  comp cnam= cnam(!cind).
- end if.
-end if.
-release rnam.
-do if ok.
  !if (!id<>!null) !then !let !idd= !id !let !idis= !conc('values of variable ',!id) !let !ifobj= 'do if obj(j)<=obj(i)'
-  get id /var= !id /miss= -999.
-  comp id= id(!rind).
-  comp missid= id=-999.
-  comp mid= csum(missid).
-  do if mid. 
-   comp missind= make(1,mid,0).
-   comp code= rnd(abs(cmax(id))).
-   comp cnt= 0.
-   loop i= 1 to nrow(missid).
-    do if missid(i).
-     comp cnt= cnt+1.
-     comp missind(cnt)= i.
-     comp id(i)= code+cnt.
-    end if.
-   end loop.
-   print /title '>WARNING. In ID-variable, missings are detected. The macro will fix'.
-   print /title '>individual codes to them.' /space= 0.
-  end if.
  !else !let !idd= 'seqno_' !let !idis= 'sequential numbers'
-  comp id= t(1:nrow(m)).
  !ifend
- comp obj= id.
  !if (!preclu<>!null) !then
-  get clu /var= !preclu /miss= -999.
-  comp clu= clu(!rind).
-  comp miss= clu=-999.
  !ifend
  !if (!n<>!null) !then !let !n_= 'n_,' !let !p1= '+1' !let !nsca= !conc('/',!n,' (sca)')
-  get n_ /var= !n.
-  comp n_= n_(!rind).
-  comp n= t(n_).
  !else
-  comp n= make(1,nrow(m),1).
  !ifend
- do if any(m<>t(m)).
-  print /title '>ERROR. Matrix compiled for analysis is not symmetric.'.
-  comp ok= 0.
- end if.
  !if (!head(!stop)='NCLU' !or !head(!stop)='STEP') !then
-  do if !ncl>nrow(m)-1 or !ncl<1.
-   print /title '>ERROR. STOP=STEP val or STOP=NCLU val specified wrongly. Val may be'.
-   print /title '>from 1 to num_objects-1.' /space= 0.
-   comp ok= 0.
-  end if.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP') !then !let !loclu= !head(!save) !let !hiclu= !head(!tail(!save))
   !if (!hiclu=!null) !then !let !hiclu= !loclu !ifend
-  do if !loclu<2 or !hiclu>nrow(m)-1 or !loclu>!hiclu.
-   print /title '>ERROR. SAVE specified incorrectly. May be 1 or 2 numbers, from 2'.
-   print /title '>to num_objects-1. 2nd must be greater than 1st.' /space= 0.
-   comp ok= 0.
   end if.
  !ifend
- do if m(1,1).
   !if (!method='CENTROID' !or !method='MEDIAN' !or !method='WARD' !or !method='MNSSQ' !or !method='MIVAR' !or !method='MNVAR') !then
-   print /title '>ERROR. With methods CENTROID, MEDIAN, WARD, MNSSQ, MIVAR, MNVAR,'.
-   print /title '>the matrix must contain distances (and desirably squared euclidean).' /space= 0.
-   comp ok= 0.
   !ifend
   !if (!cumul='YES') !then
-   print /title '>ERROR. CUMUL=YES requires distances, not similarities.'.
-   comp ok= 0.
   !ifend
- end if.
  !if (!stop='ASS2' !or !stop='ASS3') !then
-  do if not any(miss).
-   print /title '>WARNING. STOP=ASS2/ASS3, but in the variable specified in PRECLU there is no missings.'.
-   print /title '>Therefore no assignment of new objects to the assembled preexistent clusters' /space= 0.
-   print /title '>will take place.' /space= 0.
-  end if.
  !ifend
-end if.
-do if ok. 
- do if m(1,1).
-  comp simil= 1.
-  call setdiag(m,0).
-  comp m= -m.
   !if (!square='YES') !then
-   print /title '>WARNING. The input matrix is similarities, so SQUARE=YES will be ignored.'.
   !ifend
- else.
-  comp simil= 0.
   !if (!square='YES') !then
-   comp m= m&*m.
   !ifend
- end if.
- comp sgn= -2*simil+1.
  !if (!preclu<>!null) !then
-  comp clu= clu*make(1,nrow(clu),1).
-  comp clu= clu=t(clu).
-  comp clu= clu-miss*t(miss).
-  call setdiag(clu,0).
  !ifend
- comp bigval= 1E300.
  !if (!method='WAVERAGE' !or !method='MNSSQ' !or !method='MNVAR') !then !let !adds= '-s-s(i)-s(j)' !let !cmpsind= 'comp s= s(ind)'
-  comp s= make(1,nrow(m),0).
  !ifend
- comp sched= make(nrow(m)-!ncl,6,0).
  !if (!n<>!null) !then
-  comp nclui= make(nrow(sched),1,2).
-  comp ntot= rsum(n).
-  comp sched(1,6)= ntot-rsum(n=1).
  !else
-  comp ntot= nrow(m).
  !ifend
- comp memb= t({1:nrow(m)}).
- comp membs= make(nrow(m),nrow(m)-1,0).
- comp w= 0.
  !if (!method='WARD' !or !method='MNSSQ') !then
-  comp m= m/2.
  !ifend
  !if (!method='MIVAR' !or !method='MNVAR') !then
-  comp m= m/4.
  !ifend
- loop step= 1 to nrow(m)-!ncl.
   !if (!preclu<>!null) !then !let !endif= 'end if'
-   do if any(clu=make(ncol(clu),ncol(clu),1)).
-    comp m2= m&*clu+(not clu)*bigval.
-   else if any(miss).
     !if (!stop='ASS1') !then
-     break.
     !else !if (!stop='ASS3') !then
-     comp clu= miss*t(not miss).
      comp clu= clu+t(clu).
     !else !if (!stop='ASS2') !then
-     comp clu= m+(t(miss)*bigval)(make(1,nrow(m),1),:).
-     call setdiag(clu,bigval).
-     comp clu= m=(rmin(clu)+(not miss)*bigval)*make(1,ncol(m),1).
-     comp clu= clu+t(clu).
     !else
-     comp clu= not miss*t(miss).
-     call setdiag(clu,0).
     !ifend !ifend !ifend
-    comp m2= m&*clu+(not clu)*bigval.
-   else.
   !ifend
     !if (!ass) !then !let !mone= '-1'
-     break.
     !else
-     comp m2= m.
     !ifend
-   !endif.
-  call setdiag(m2,bigval).
-  comp min= mmin(m2).
-  comp m2= (m2=min)&*(1:ncol(m2))(make(1,nrow(m2),1),:).
-  comp jv = rmax(m2).
-  loop i= nrow(m) to 1 by -1.
-  end loop if jv(i).
-  comp j= jv(i).
   !if (!method='SINGLE') !then !let !lab= 'single linkage (nearest neighbour).'
-   comp m(j,:)= cmin({m(i,:);m(j,:)}).
   !ifend
   !if (!method='COMPLETE') !then !let !lab= 'complete linkage (farthest neighbour).'
-   comp m(j,:)= cmax({m(i,:);m(j,:)}).
   !ifend
   !let !beta= '+beta&*m(i,j)' !let !denom= '/denom'
   !if (!head(!method)='BAVERAGE') !then !let !lab= 'between-group average linkage (UPGMA).' !let !denom= !null
    !if (!tail(!method)<>!null) !then !let !lab= !conc('between-group average linkage (UPGMA) with flexibility parameter',!tail(!method),'.')
     !let !flex= !conc('(1-',!tail(!method),')*')
-    comp beta= !tail(!method).
    !else !let !beta= !null
    !ifend
-   comp alpha1= !flex n(i)/(n(i)+n(j)).
-   comp alpha2= !flex n(j)/(n(i)+n(j)).
   !ifend
   !if (!head(!method)='EQBAVER') !then !let !lab= 'equilibrious between-group average linkage (WPGMA).' !let !denom= !null
    !if (!tail(!method)<>!null) !then !let !lab= !conc('equilibrious between-group average linkage (WPGMA) with flex-ty parameter',!tail(!method),'.')
     !let !flex= !conc('(1-',!tail(!method),')*')
-    comp beta= !tail(!method).
    !else !let !beta= !null
    !ifend
-   comp alpha1= !flex .5.
-   comp alpha2= !flex .5.
   !ifend
   !if (!method='WAVERAGE') !then !let !lab= 'within-group average linkage (MNDIS).' !let !cmps= 'comp s(j)= min*n(j)*(n(j)-1)/2'
-   comp alpha1= n+n(i).
-   comp alpha1= alpha1&*(alpha1-1)/2.
-   comp alpha2= n+n(j).
-   comp alpha2= alpha2&*(alpha2-1)/2.
-   comp beta= n(i)+n(j).
-   comp beta= beta&*(beta-1)/2.
-   comp denom= n+n(i)+n(j).
-   comp denom= denom&*(denom-1)/2.
   !ifend
   !if (!method='CENTROID') !then !let !lab= 'centroid (UPGMC).' !let !denom= !null
-   comp alpha1= n(i)/(n(i)+n(j)).
-   comp alpha2= n(j)/(n(i)+n(j)).
-   comp beta= -alpha1*alpha2.
   !ifend
   !if (!method='MEDIAN') !then !let !lab= 'median (equilibrious centroid, WPGMC).'
-   comp alpha1= 1.
-   comp alpha2= 1.
-   comp beta= -.5.
-   comp denom= 2.
   !ifend
   !if (!method='WARD') !then !let !lab= "Ward's (increase of sum-of-squares, MISSQ)."
-   comp alpha1= n+n(i).
-   comp alpha2= n+n(j).
-   comp beta= -n.
-   comp denom= n+n(i)+n(j).
   !ifend
   !if (!method='MNSSQ') !then !let !lab= 'sum-of-squares (MNSSQ).' !let !cmps= 'comp s(j)= min*n(j)'
-   comp alpha1= n+n(i).
-   comp alpha2= n+n(j).
-   comp beta= n(i)+n(j).
-   comp denom= n+beta.
   !ifend
   !if (!method='MIVAR') !then !let !lab= 'increase of variance (MIVAR).'
-   comp alpha1= (n+n(i))&**2.
-   comp alpha2= (n+n(j))&**2.
-   comp beta= -n&*(n(i)+n(j)).
-   comp denom= (n+n(i)+n(j))&**2.
   !ifend
   !if (!method='MNVAR') !then !let !lab= 'variance (MNVAR).' !let !cmps= 'comp s(j)= min*n(j)**2'
-   comp alpha1= (n+n(i))&**2.
-   comp alpha2= (n+n(j))&**2.
-   comp beta= (n(i)+n(j))&**2.
-   comp denom= (n+n(i)+n(j))&**2.
   !ifend
   !if (!index('CENTROID MEDIAN WARD MNSSQ MIVAR MNVAR',!method)>0 !and !root='YES') !then
-   comp min= sqrt(min).
   !ifend
   !if (!cumul='YES') !then !let !w= 'w' !let !cuminfo= ' (requested to return cumulated)'
-   comp w= w+min.
   !else !let !w= 'min'
   !ifend
   !if (!method<>'SINGLE' !and !method<>'COMPLETE') !then
-   comp m(j,:)= (alpha1&*m(i,:)+alpha2&*m(j,:) !beta !adds) !denom.
   !ifend
-  comp m(:,j)= t(m(j,:)).
-  comp sing= (n(i)=1)+(n(j)=1).
   !if (!head(!stop)='BOTHN') !then !let !eloopif= 'if bothn'
-   comp bothn= n(i)>=!tail(!stop) and n(j)>=!tail(!stop).
   !ifend
-  comp n(j)= n(i)+n(j).
-  !cmps.
-  do if i=nrow(m).
-   comp ind= {1:(i-1)}.
-  else.
-   comp ind= {1:(i-1),(i+1):nrow(m)}.
-  end if.
-  comp m= m(ind,ind).
-  comp n= n(ind).
-  !cmpsind.
   !if (!preclu<>!null) !then
    !if (!stop='ASS2' !or !stop='ASS3') !then
-    do if miss(j).
-     comp clu(j,:)= clu(i,:).
-     comp clu(:,j)= clu(:,i). 
-     comp clu(j,j)= 0.
-     comp miss(j)= 0.
     end if.
    !ifend
-   comp clu= clu(ind,ind).
-   comp miss= miss(ind).
   !ifend
-   !ifobj.
-    comp sched(step,:)= {obj(j),obj(i),sgn*!w,j,n(j),sched(step-(step>1),6)+sing}.
   !if (!id<>!null) !then
-   else.
-    comp sched(step,:)= {obj(i),obj(j),sgn*!w, J ,n(j),sched(step-(step>1),6)+sing}.
-    comp obj(j)= obj(i).
-   end if.
   !ifend
   !if (!n<>!null) !then
-   do if step>1.
-    comp nclui(step)= nclui(step-1)+all(sched(1:(step-1),1)<>sched(step,2))+all(sched(1:(step-1),1)<>sched(step,1)).
-   end if.
   !ifend
   !if (!save<>!null) !then
-   comp memb= memb&*(memb<>i)+(memb=i)*j.
-   comp memb= memb-(memb>=i).
-   comp membs(:,step)= memb.
   !ifend
-  comp obj= obj(ind).
- end loop !eloopif.
- do if step !mone<nrow(sched).
-  comp sched= sched(1:(step !mone),:).
- end if.
- comp sched(:,6)= sched(:,6)/ntot.
  !if (!n<>!null) !then !let !iproplab= !quote('IPropClu') !let !ipropclu= 'ipropclu'
   !let !iproppr= 'print /title " IPropClu - proportion of matrix rows/columns clustered" /space= 0'
-  comp sched= {sched,nclui(1:nrow(sched))/nrow(id)}.
  !ifend
- print /title '**** HIERARCHICAL CLUSTERING ****'.
- do if simil.
-  print nrow(id) /title 'Input was matrix of similarities of size:'.
- else.
- print nrow(id) /title 'Input was matrix of dissimilarities/distances of size:'.
- end if.
  !if (!print<>'NOID' !and !print<>'SUMM') !then
-  do if cmp.
-   print /title 'Names and ID of rows/columns in the matrix compiled for analysis'.
-   print t(id) /title !quote(!conc('(ID are ',!idis,'):')) /cnam= cnam /space= 0.
-  else.
-   print /title !quote(!conc('ID of rows/columns are ',!idis,'.')).
-  end if.
   !if (!id<>!null) !then
-   do if mid.
-    comp mnam= cnam(missind).
-    print id(missind) /title 'These rows/columns got ID fixed because they were missing:' /rnam= mnam /clab= 'ID'.
-   end if.
   !ifend
  !ifend
- print ntot /title 'Number of objects participating in clustering:'.
  !if (!preclu<>!null) !then
-  print /title !quote(!conc('Preexistent structure specified: ',!preclu,'.')).
  !ifend
- print /title 'Linkage method used:'.
- print /title !quote(!lab) /space= 0.
  !if (!print<>'NOSCHED' !and !print<>'SUMM') !then
-  print /title 'Agglomeration schedule:'.
-  print /title ' Step - step of agglomeration' /space= 0.
-  print /title ' Cluster1, Cluster2 - merging clusters, by ID of matrix rows/columns' /space= 0.
-  print /title !quote(!conc(' Coef. - coefficient of colligation',!cuminfo)) /space= 0.
-  print /title " CluCode - emergent cluster code in the step's cluster membership variable" /space= 0.
-  print /title ' CluN - frequency in the emergent cluster' /space= 0.
-  print /title ' PropClu - overall proportion of objects clustered' /space= 0.
-  !iproppr.
-  print {t(1:nrow(sched)),sched} /title ' ' /clab= 'Step' 'Cluster1' 'Cluster2' 'Coef.' 'CluCode' 'CluN' 'PropClu' !iproplab /format= f10.3 /space= 0.
  !ifend
  !if (!stop<>!null) !then
-  do if nrow(m)=1.
-   print /title !quote(!conc('Agglomeration was to stop by request: ',!stop,', but went to the end')).
-   print /title '(either the request was not satisfied or was satisfied on the last step, - check' /space= 0.
-   print /title 'by the agglomeration schedule).' /space= 0.
-  else.
-   print /title !quote(!conc('Agglomeration stopped by request: ',!stop,'.')).
-  end if.
   !if (!not !ass) !then
-   do if sched(nrow(sched),6)<1.
-    print /title 'Some objects remained outside clusters and did not enter' /space= 0.
-    print /title 'agglomeration schedule.' /space= 0.
-   end if.
   !ifend
   !if (!save<>!null !and !save<>'ATSTOP') !then
-   print /title 'Some of the saved cluster membership variables may appear empty.' /space= 0.
   !ifend
   !if (!msave<>!null) !then
-   print nrow(m) /title 'At the moment of stop, matrix of this size was saved to the external file:' /space= 0.
   !ifend
  !ifend
  !if (!sched<>!null) !then
-  save {t(1:nrow(sched)),sched} /out= !sched /vari= step cluster1 cluster2 coef clucode clun propclu !ipropclu.
  !ifend
  !if (!save='ALL') !then
-  save {!n_ id,t(cnam),membs(:,1:(ncol(membs)-1))} /out= * /vari= !n !idd varname_ clu2 to clu50000 /string= varname_.
  !ifend
  !if (!save='ATSTOP') !then
-  save {!n_ id,t(cnam),membs(:,(nrow(sched)-1):nrow(sched))} /out= * /vari= !n !idd varname_ clustop clustop# /string= varname_.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP' !and !hiclu=!loclu) !then
-  save {!n_ id,t(cnam),membs(:,ncol(membs)-!loclu+1)} /out= * /vari= !n !idd varname_ !conc('clu',!loclu) /string= varname_.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP' !and !hiclu<>!loclu) !then
-  save {!n_ id,t(cnam),membs(:,(ncol(membs)-!hiclu+1):(ncol(membs)-!loclu+1))}
                        /out= * /vari= !n !idd varname_ !conc('clu',!loclu) to !conc('clu',!hiclu) /string= varname_.
  !ifend
  !if (!msave<>!null !and !stop<>!null) !then
   !if (!method='WARD' !or !method='MNSSQ') !then
-   comp m= m*2.
   !ifend
   !if (!method='MIVAR' !or !method='MNVAR') !then
-   comp m= m*4.
   !ifend
-  do if simil.
-   comp m= -m.
-   call setdiag(m,999).
-  else.
-   call setdiag(m,0).
-  end if.
-  save {t(n),obj,m} /out= !msave /vari= col1 col2 var1 to var100000.
  !ifend
 !if (!save<>!null) !then
- else.
-  save 0 /out= *.
 !ifend
-end if.
!ifend
end matrix.
!if (!ok) !then
 !if (!msave<>!null !and !stop<>!null) !then
- matrix.
- get m /file= !msave /names= vnam.
- comp vnam= vnam(3:ncol(vnam)).
- comp names= {'method_','rowtype_','n_',!quote(!idd),'varname_',vnam}.
- save {make(nrow(m),1,!quote(!head(!method))),make(nrow(m),1,'PROX'),m(:,1:2),t(vnam),m(:,3:ncol(m))} /out= !msave /names= names /string= method_ rowtype_ varname_.
- end matrix.
 !ifend
 !if (!save<>!null) !then
- matrix.
- get membs /names= names.
- comp names(grade(-{(3 !p1):ncol(names)})+(2 !p1))= names((3 !p1):ncol(names)).
- save membs /out= * /names= names /string= varname_.
- end matrix.
- var lev all (nom) !nsca.
 !ifend
!ifend
!enddefine.

*/*!KO_HIECLUEX*/vers1***************************************************************************************.
define !KO_hiecluex(matrix= !charend('/') /seq= !charend('/') /fw= !charend('/') /id= !charend('/') /method= !charend('/') /stop= !charend('/') /save= !charend('/')
                /msave= !charend('/') /sched= !charend('/') /print= !charend('/'))
!let !ncl= 1
!if (!head(!stop)='NCLU' !or !head(!stop)='STEP') !then
 !if (!head(!stop)='NCLU') !then !let !ncl= !tail(!stop) !else !let !ncl= !conc('(nrow(m)-',!tail(!stop),')') !ifend
!else
 !if (!head(!stop)='PROP') !then !let !eloopif= !conc('if sched(step,6)/ntot>=',!tail(!stop))
 !else !if (!head(!stop)='IPROP') !then !let !eloopif= !conc('if nclui(step)/nrow(id)>=',!tail(!stop))
 !else !if (!head(!stop)='COEF') !then !let !eloopif= !conc('if sched(step,3)>=',!tail(!stop))
 !else !if (!head(!stop)='MAXN') !then !let !eloopif= !conc('if n(j)>=',!tail(!stop))
 !ifend !ifend !ifend !ifend
!ifend
set mxloops 1E6.
matrix.
!let !ok= 1
!if (!fw=!null !and !head(!stop)='IPROP') !then !let !ok= 0
-print /title '>ERROR. STOP=IPROP requires subcommand FW be specified.'.
!ifend
!if (!msave<>!null !and !stop=!null) !then !let !ok= 0
-print /title '>ERROR. MSAVE requires subcommand STOP be specified.'.
!ifend
!if (!save='ATSTOP' !and !stop=!null) !then !let !ok= 0
-print /title '>ERROR. SAVE=ATSTOP requires subcommand STOP be specified.'.
!ifend
!if (!ok) !then
 !let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
 !if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
 !let !lm= !len(!matr)
 !if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
-comp ok= 1.
-get m /vari= !matr /names= cnam.
 !if (!fcrop) !then
- comp m= m(:,2:ncol(m)).
- comp cnam= cnam(:,2:ncol(cnam)). 
 !ifend
 !if (!lcrop) !then
- comp m= m(:,1:(ncol(m)-1)).
- comp cnam= cnam(:,1:(ncol(cnam)-1)).
 !ifend
-get rnam /var= varname_.
-comp rnam= t(rnam).
 !if (!seq='COL' !or !seq=!null) !then
  !let !seq1= 'cnam' !let !seq2= 'rnam' !let !rind= 'ind2' !let !cind= 'ind1'
 !else
  !let !seq1= 'rnam' !let !seq2= 'cnam' !let !rind= 'ind1' !let !cind= 'ind2'
 !ifend
-do if nrow(m)<>ncol(m).
- comp cmp= 1.
-else if any(rnam<>cnam).
- comp cmp= 1.
-else.
- comp cmp= 0.
- comp ind1= 1:ncol(m).
- comp ind2= 1:ncol(m).
-end if.
-do if cmp.
- comp flag= kroneker(t(!seq1),make(1,ncol(!seq2),1))=kroneker(!seq2,make(ncol(!seq1),1,1)).
- comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
- release flag.
- comp nnz= msum(ind2>0).
- do if nnz<3.
-  print /title '>ERROR. Among input matrix column names and row names there are too few identical'.
-  print /title '>to be able to compile matrix for analysis.' /space= 0.
-  comp ok= 0.
- else.
-  comp ind1= make(1,nnz,0).
-  comp cnt= 0.
-  loop i= 1 to nrow(ind2).
-   do if ind2(i).
-    comp cnt= cnt+1.
-    comp ind1(cnt)= i.
-   end if.
-  end loop.
-  comp ind2= ind2(ind1).
-  comp m= m(!rind,!cind).
-  comp cnam= cnam(!cind).
- end if.
-end if.
-release rnam.
-do if ok.
  !if (!id<>!null) !then !let !idd= !id !let !idis= !conc('values of variable ',!id) !let !ifobj= 'do if obj(j)<=obj(i)'
-  get id /var= !id.
-  comp id= id(!rind).
  !else !let !idd= 'seqno_' !let !idis= 'sequential numbers'
-  comp id= t(1:nrow(m)).
  !ifend
- comp obj= id.
  !if (!fw<>!null) !then !let !fw_= 'fw_,' !let !p1= '+1' !let !nsca= !conc('/',!fw,' (sca)')
-  get fw_ /var= !fw.
-  comp fw_= fw_(!rind).
-  comp n= fw_.
  !else
-  comp n= make(nrow(m),1,1).
  !ifend
- comp q= make(nrow(m),1,1).
- do if any(m<>t(m)).
-  print /title '>ERROR. Matrix compiled for analysis is not symmetric.'.
-  comp ok= 0.
- end if.
  !if (!head(!stop)='NCLU' !or !head(!stop)='STEP') !then
-  do if !ncl>nrow(m)-1 or !ncl<1.
-   print /title '>ERROR. STOP=STEP val or STOP=NCLU val specified wrongly. Val may be'.
-   print /title '>from 1 to num_objects-1.' /space= 0.
-   comp ok= 0.
-  end if.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP') !then !let !loclu= !head(!save) !let !hiclu= !head(!tail(!save))
   !if (!hiclu=!null) !then !let !hiclu= !loclu !ifend
-  do if !loclu<2 or !hiclu>nrow(m)-1 or !loclu>!hiclu.
-   print /title '>ERROR. SAVE specified incorrectly. May be 1 or 2 numbers, from 2'.
-   print /title '>to num_objects-1. 2nd must be greater than 1st.' /space= 0.
-   comp ok= 0.
   end if.
  !ifend
- do if m(1,1).
-  print /title '>ERROR. Matrix must contain distances, not similarities.'.
-  comp ok= 0.
- end if.
-end if.
-do if ok. 
- comp bigval= 1E300.
- comp sched= make(nrow(m)-!ncl,6,0).
  !if (!fw<>!null) !then
-  comp nclui= make(nrow(sched),1,2).
-  comp ntot= csum(n).
-  comp sched(1,6)= ntot-csum(n=1).
  !else
-  comp ntot= nrow(m).
  !ifend
- comp memb= t({1:nrow(m)}).
- comp membs= make(nrow(m),nrow(m)-1,0).
- comp inds= make(nrow(m),nrow(m),0).
- comp inds(1,:)= 1:nrow(m).
  !if (!method='HAUSDORFF' !or !method='MHAUSDORFF') !then
-  comp pgd= m.
  !else
-  print /title '>REMINDER. METHOD=CROSSPC normally expects input distances to be'.
-  print /title ' nonsquared euclidean.' /space= 0.
-  comp pgd= m&*m.
   !if (!fw<>!null) !then
-   comp pgd= pgd&*t(fw_)(make(1,nrow(pgd),1),:).
   !ifend
-  comp sum= make(nrow(m),1,0).
  !ifend
- loop step= 1 to nrow(m)-!ncl.
-  call setdiag(m,bigval).
-  comp min= mmin(m).
-  comp jv= rmax((m=min)&*(1:ncol(m))(make(1,nrow(m),1),:)).
-  loop i= nrow(m) to 1 by -1.
-  end loop if jv(i).
-  comp j= jv(i).
-  comp qij= q(i)+q(j).
-  comp nij= n(i)+n(j).
-  comp sing= (n(i)=1)+(n(j)=1).
-  comp indsi= inds(1:q(i),i).
-  comp inds((q(j)+1):qij,j)= indsi.
   !if (!head(!stop)='BOTHN') !then !let !eloopif= 'if bothn'
-   comp bothn= n(i)>=!tail(!stop) and n(j)>=!tail(!stop).
   !ifend
-  comp q(j)= qij.
-  comp n(j)= nij.
   !if (!method='CROSSPC') !then
-   comp sum(j)= sum(j)+sum(i)+csum(pgd(indsi,j) !if (!fw<>!null) !then &*fw_(indsi) !ifend).
   !ifend
   !if (!method='HAUSDORFF' !or !method='MHAUSDORFF') !then
-   comp cij= rmin(pgd(:,{j,i})).
   !else
-   comp cij= rsum(pgd(:,{j,i})).
   !ifend
-  comp pgd(:,j)= cij.
-  do if i=nrow(m).
-   comp ind= {1:(i-1)}.
-  else.
-   comp ind= {1:(i-1),(i+1):nrow(m)}.
-  end if.
-  comp m= m(ind,ind).
-  comp inds= inds(:,ind).
-  comp pgd= pgd(:,ind).
-  comp q= q(ind).
-  comp n= n(ind).
   !if (!method='HAUSDORFF' !or !method='MHAUSDORFF') !then
-   comp qgt1= q>1.
   !else
-   comp sum= sum(ind).
   !ifend
   !if (!method='HAUSDORFF' !or !method='MHAUSDORFF') !then
-   comp v_j= make(1,ncol(m),0).
-   loop c= 1 to ncol(inds).
-    do if c=j.
      !if (!method='HAUSDORFF') !then !let !lab= 'Hausdorff distance.'
-      comp vj_= cmax(pgd(inds(1:q(j),j),:)).
      !else !let !lab= 'Modified Hausdorff distance.'
-      comp vj_= csum(pgd(inds(1:q(j),j),:) !if (!fw<>!null) !then &*(fw_(inds(1:q(j),j))*make(1,ncol(pgd),1)) !ifend)/nij.
      !ifend
-    else.
-     do if qgt1(c).
       !if (!method='HAUSDORFF') !then
-       comp v_j(c)= cmax(cij(inds(1:q(c),c))).
       !else
-       comp v_j(c)= csum(cij(inds(1:q(c),c)) !if (!fw<>!null) !then &*fw_(inds(1:q(c),c)) !ifend)/n(c).
       !ifend
-     end if.
-    end if.
-   end loop.
-   comp vjg= vj_>=v_j.
-   comp vjg= vj_&*vjg+v_j&*(not vjg).
-   comp m(j,:)= vjg.
-   comp m(:,j)= t(vjg).
   !else !let !lab= 'Point-centroid cross-distance.'
-   comp mean= sum/n.
-   comp meanij= mean(j).
-   loop c= 1 to ncol(inds).
-    comp nc= n(c).
-    comp pccij= sqrt((cij(inds(1:q(c),c))-meanij)/nij).
-    comp pccij= csum(pccij !if (!fw<>!null) !then &*fw_(inds(1:q(c),c)) !ifend).
-    comp pijcc= sqrt((pgd(inds(1:qij,j),c)-mean(c))/nc).
-    comp pijcc= csum(pijcc !if (!fw<>!null) !then &*fw_(inds(1:qij,j)) !ifend).
-    comp crosspc= (pccij+pijcc)/(nij+nc).
-    comp m(j,c)= crosspc.
-    comp m(c,j)= crosspc.
-   end loop.
   !ifend
-   !ifobj.
-    comp sched(step,:)= {obj(j),obj(i),min,j,n(j),sched(step-(step>1),6)+sing}.
   !if (!id<>!null) !then
-   else.
-    comp sched(step,:)= {obj(i),obj(j),min,j,n(j),sched(step-(step>1),6)+sing}.
-    comp obj(j)= obj(i).
-   end if.
   !ifend
   !if (!fw<>!null) !then
-   do if step>1.
-    comp nclui(step)= nclui(step-1)+all(sched(1:(step-1),1)<>sched(step,2))+all(sched(1:(step-1),1)<>sched(step,1)).
-   end if.
   !ifend
   !if (!save<>!null) !then
-   comp memb= memb&*(memb<>i)+(memb=i)*j.
-   comp memb= memb-(memb>=i).
-   comp membs(:,step)= memb.
   !ifend
-  comp obj= obj(ind).
- end loop !eloopif.
- do if step<nrow(sched).
-  comp sched= sched(1:step,:).
- end if.
- comp sched(:,6)= sched(:,6)/ntot.
  !if (!fw<>!null) !then !let !iproplab= !quote('IPropClu') !let !ipropclu= 'ipropclu'
   !let !iproppr= 'print /title " IPropClu - proportion of matrix rows/columns clustered" /space= 0'
-  comp sched= {sched,nclui(1:nrow(sched))/nrow(id)}.
  !ifend
- print /title '**** HIERARCHICAL CLUSTERING (exotic linkage) ****'.
- print nrow(id) /title 'Input was matrix of dissimilarities/distances of size:'.
  !if (!print<>'NOID' !and !print<>'SUMM') !then
-  do if cmp.
-   print /title 'Names and ID of rows/columns in the matrix compiled for analysis'.
-   print t(id) /title !quote(!conc('(ID are ',!idis,'):')) /cnam= cnam /space= 0.
-  else.
-   print /title !quote(!conc('ID of rows/columns are ',!idis,'.')).
-  end if.
  !ifend
- print ntot /title 'Number of objects participating in clustering:'.
- print /title 'Linkage method used:'.
- print /title !quote(!lab) /space= 0.
  !if (!print<>'NOSCHED' !and !print<>'SUMM') !then
-  print /title 'Agglomeration schedule:'.
-  print /title ' Step - step of agglomeration' /space= 0.
-  print /title ' Cluster1, Cluster2 - merging clusters, by ID of matrix rows/columns' /space= 0.
-  print /title ' Coef. - coefficient of colligation' /space= 0.
-  print /title " CluCode - emergent cluster code in the step's cluster membership variable" /space= 0.
-  print /title ' CluN - frequency in the emergent cluster' /space= 0.
-  print /title ' PropClu - overall proportion of objects clustered' /space= 0.
-  !iproppr.
-  print {t(1:nrow(sched)),sched} /title ' ' /clab= 'Step' 'Cluster1' 'Cluster2' 'Coef.' 'CluCode' 'CluN' 'PropClu' !iproplab /format= f10.3 /space= 0.
  !ifend
  !if (!stop<>!null) !then
-  do if nrow(m)=1.
-   print /title !quote(!conc('Agglomeration was to stop by request: ',!stop,', but went to the end')).
-   print /title '(either the request was not satisfied or was satisfied on the last step, - check' /space= 0.
-   print /title 'by the agglomeration schedule).' /space= 0.
-  else.
-   print /title !quote(!conc('Agglomeration stopped by request: ',!stop,'.')).
-  end if.
-  do if sched(nrow(sched),6)<1.
-   print /title 'Some objects remained outside clusters and did not enter' /space= 0.
-   print /title 'agglomeration schedule.' /space= 0.
-  end if.
   !if (!save<>!null !and !save<>'ATSTOP') !then
-   print /title 'Some of the saved cluster membership variables may appear empty.' /space= 0.
   !ifend
   !if (!msave<>!null) !then
-   print nrow(m) /title 'At the moment of stop, matrix of this size was saved to the external file:' /space= 0.
   !ifend
  !ifend
  !if (!sched<>!null) !then
-  save {t(1:nrow(sched)),sched} /out= !sched /vari= step cluster1 cluster2 coef clucode clun propclu !ipropclu.
  !ifend
  !if (!save='ALL') !then
-  save {!fw_ id,t(cnam),membs(:,1:(ncol(membs)-1))} /out= * /vari= !fw !idd varname_ clu2 to clu50000 /string= varname_.
  !ifend
  !if (!save='ATSTOP') !then
-  save {!fw_ id,t(cnam),membs(:,(nrow(sched)-1):nrow(sched))} /out= * /vari= !fw !idd varname_ clustop clustop# /string= varname_.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP' !and !hiclu=!loclu) !then
-  save {!fw_ id,t(cnam),membs(:,ncol(membs)-!loclu+1)} /out= * /vari= !fw !idd varname_ !conc('clu',!loclu) /string= varname_.
  !ifend
  !if (!save<>!null !and !save<>'ALL' !and !save<>'ATSTOP' !and !hiclu<>!loclu) !then
-  save {!fw_ id,t(cnam),membs(:,(ncol(membs)-!hiclu+1):(ncol(membs)-!loclu+1))}
                        /out= * /vari= !fw !idd varname_ !conc('clu',!loclu) to !conc('clu',!hiclu) /string= varname_.
  !ifend
  !if (!msave<>!null !and !stop<>!null) !then
-  call setdiag(m,0).
-  save {n,obj,m} /out= !msave /vari= col1 col2 var1 to var100000.
  !ifend
 !if (!save<>!null) !then
- else.
-  save 0 /out= *.
 !ifend
-end if.
!ifend
end matrix.
!if (!ok) !then
 !if (!msave<>!null !and !stop<>!null) !then
- matrix.
- get m /file= !msave /names= vnam.
- comp vnam= vnam(3:ncol(vnam)).
- comp names= {'method_','rowtype_','n_',!quote(!idd),'varname_',vnam}.
- save {make(nrow(m),1,!quote(!head(!method))),make(nrow(m),1,'PROX'),m(:,1:2),t(vnam),m(:,3:ncol(m))} /out= !msave /names= names /string= method_ rowtype_ varname_.
- end matrix.
 !ifend
 !if (!save<>!null) !then
- matrix.
- get membs /names= names.
- comp names(grade(-{(3 !p1):ncol(names)})+(2 !p1))= names((3 !p1):ncol(names)).
- save membs /out= * /names= names /string= varname_.
- end matrix.
- var lev all (nom) !nsca.
 !ifend
!ifend
!enddefine.

*/*!KO_ASSCLU*/vers2***************************************************************************************.
define !KO_assclu(matrix= !charend('/') /seq= !charend('/') /id= !charend('/') /cluvar= !charend('/') /square= !charend('/') /method= !charend('/')
              /save= !charend('/') /msave1= !charend('/') /msave2= !charend('/') /print= !charend('/'))
set mxloops 1E6.
matrix.
!let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
!if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
!let !lm= !len(!matr)
!if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
comp ok= 1.
get m /vari= !matr /names= cnam.
!if (!fcrop) !then
-comp m= m(:,2:ncol(m)).
-comp cnam= cnam(:,2:ncol(cnam)). 
!ifend
!if (!lcrop) !then
-comp m= m(:,1:(ncol(m)-1)).
-comp cnam= cnam(:,1:(ncol(cnam)-1)).
!ifend
get rnam /var= varname_.
comp rnam= t(rnam).
!if (!seq='COL' !or !seq=!null) !then
 !let !seq1= 'cnam' !let !seq2= 'rnam' !let !rind= 'ind2' !let !cind= 'ind1'
!else
 !let !seq1= 'rnam' !let !seq2= 'cnam' !let !rind= 'ind1' !let !cind= 'ind2'
!ifend
do if nrow(m)<>ncol(m).
-comp cmp= 1.
else if any(rnam<>cnam).
-comp cmp= 1.
else.
-comp cmp= 0.
-comp ind1= 1:ncol(m).
-comp ind2= 1:ncol(m).
end if.
do if cmp.
-comp flag= kroneker(t(!seq1),make(1,ncol(!seq2),1))=kroneker(!seq2,make(ncol(!seq1),1,1)).
-comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
-release flag.
-comp nnz= msum(ind2>0).
-do if nnz<3.
- print /title '>ERROR. Among input matrix column names and row names there are too few identical'.
- print /title '>to be able to compile matrix for analysis.' /space= 0.
- comp ok= 0.
-else.
- comp ind1= make(1,nnz,0).
- comp cnt= 0.
- loop i= 1 to nrow(ind2).
-  do if ind2(i).
-   comp cnt= cnt+1.
-   comp ind1(cnt)= i.
-  end if.
- end loop.
- comp ind2= ind2(ind1).
- comp m= m(!rind,!cind).
- comp cnam= cnam(!cind).
-end if.
end if.
do if ok.
-get id /var= !id.
-comp id= id(!rind).
-get clu /var= !cluvar /miss= -999.
-comp clu= clu(!rind).
-comp miss= clu=-999.
-do if nrow(m)<>ncol(m).
- print /title '>ERROR. Matrix is not square.'.
- comp ok= 0.
-else if any(m<>t(m)).
- print /title '>ERROR. Matrix is not symmetric.'.
- comp ok= 0.
 !if (!method='CENTROID' !or !method='WARD' !or !method='MNSSQ' !or !method='MIVAR' !or !method='MNVAR' !or !method='CROSSPC') !then
- else if m(1,1).
-  print /title '>ERROR. With methods CENTROID, WARD, MNSSQ, MIVAR, MNVAR, CROSSPC,'.
-  print /title '>the matrix must contain distances, not similarities.' /space= 0.
-  comp ok= 0.
 !ifend
-end if.
end if.
do if ok.
-do if m(1,1).
- comp simil= 1.
- call setdiag(m,0).
- comp m= -m.
  !if (!square='YES') !then
-  print /title '>WARNING. The input matrix is similarities, so SQUARE=YES will be ignored.'.
  !ifend
-else.
- comp simil= 0.
  !if (!method='CROSSPC') !then
-  comp m= m&*m.
   !if (!square='YES') !then
-   print /title '>WARNING. METHOD=CROSSPC, so SQUARE=YES will be ignored.'.
   !ifend
  !else !if (!square='YES') !then
-  comp m= m&*m.
  !ifend !ifend
-end if.
-comp nmiss= csum(miss).
-do if nmiss.
- comp missind= make(nmiss,1,0).
- comp ind= make(nrow(clu)-nmiss,1,0).
- comp cnt1= 0.
- comp cnt2= 0.
- loop i= 1 to nrow(clu).
-  do if miss(i).
-   comp cnt1= cnt1+1.
-   comp missind(cnt1)= i.
-  else.
-   comp cnt2= cnt2+1.
-   comp ind(cnt2)= i.
-  end if.
- end loop.
- comp mcodes= id(missind).
- comp id= id({ind;missind}).
- comp cnam= cnam({ind;missind}).
- comp clu= clu(ind).
- comp mm= m(missind,missind).
  !if (!save='YES') !then
-  do if nmiss=1.
-   comp mmptpt= -99999999.99999999.
-  else.
-   comp bigval= 1E300.
-   comp mmptpt= mm.
-   call setdiag(mmptpt,bigval).
-   comp mmptpt= rmin(mmptpt).
-  end if.
  !ifend
- comp nmm= m(ind,missind).
- comp m= m(ind,ind).
-else.
  !if (!msave1=!null !and !msave2=!null) !then
-  print /title '>WARNING. CLUVAR-variable has no missings (objects for assignment) and'.
-  print /title '>MSAVE subcommands are not specified. That means the macro was run without use.' /space= 0.
  !else
-  print /title '>WARNING. CLUVAR-variable has no missings (objects for assignment).'.
-  print /title '>That means that subcommands MSAVE1 and MSAVE2 are equivalent.' /space= 0.
  !ifend
  !if (!save='YES') !then
-  print /title '>WARNING. SAVE=YES, but CLUVAR-variable has no missings (objects for assignment),'.
-  print /title '>therefore the saved cluster membership variable will be of no use.' /space= 0.
  !ifend
-end if.
-comp des= design(clu).
-print /title '**** CLUSTER ASSEMBLY / OBJECT ASSIGNMENT TO CLUSTERS ****'.
-do if simil.
- print nrow(id) /title 'Input was matrix of similarities of size:'.
-else.
- print nrow(id) /title 'Input was matrix of dissimilarities/distances of size:'.
-end if.
 !if (!print<>'NOID' !and !print<>'SUMM') !then
- do if cmp.
-  print /title 'Names and ID of rows/columns in the matrix compiled before the procedure'.
-  print t(id) /title !quote(!conc('(ID are values of variable ',!id,'):')) /cnam= cnam /space= 0.
- else.
-  print /title !quote(!conc('ID of rows/columns are values of variable ',!id,'.')).
- end if.
 !ifend
-print ncol(des) /title !quote(!conc('Number of clusters (groups) according to variable ',!cluvar,':')).
-print nmiss /title 'Number of new objects for assignment:'.
-print /title !quote(!conc('Method used: ',!method)).
-loop ass= 1 to 1+(nmiss>0).
- comp n= csum(des).
- do if ass=1.
-  comp codes= csum(clu*make(1,ncol(des),1)&*des)/n.
- end if.
  !if (!method='SINGLE' !or !method='COMPLETE' !or !method='HAUSDORFF' !or !method='MHAUSDORFF') !then
-  comp @m= des.
-  loop @i= 2 to nrow(@m).
-   comp @m(@i,:)= @m(@i-1,:)+@m(@i,:).
-  end loop.
-  comp @m= @m&*des.
-  comp inds= make(nrow(@m)+1,ncol(@m),0).
-  comp @nums= t(1:nrow(@m)).
-  comp @m= @m+(not @m)*nrow(inds).
-  loop @i= 1 to ncol(@m).
-   comp inds(@m(:,@i),@i)= @nums.
-  end loop.
-  comp inds= inds(1:(nrow(inds)-1),:).
-  release @m,@nums.
-  comp cc= make(ncol(des),ncol(des),0).
-  loop i= 1 to ncol(des)-1.
-   loop j= i+1 to ncol(des).
     !if (!method='SINGLE') !then
-     comp cc(i,j)= mmin(m(inds(1:n(i),i),inds(1:n(j),j))).
     !else !if (!method='COMPLETE') !then
-     comp cc(i,j)= mmax(m(inds(1:n(i),i),inds(1:n(j),j))).
     !else !if (!method='HAUSDORFF') !then
-     comp m_= m(inds(1:n(i),i),inds(1:n(j),j)).
-     comp cc(i,j)= mmax({mmax(rmin(m_)),mmax(cmin(m_))}).
     !else
-     comp m_= m(inds(1:n(i),i),inds(1:n(j),j)).
-     comp cc(i,j)= mmax({msum(rmin(m_))/nrow(m_),msum(cmin(m_))/ncol(m_)}).
     !ifend !ifend !ifend
-   end loop.
-  end loop.
-  comp cc= cc+t(cc).
  !else
   !if (!method='CROSSPC') !then
-   comp m_= m*des.
-   comp wgs= diag(t(des)*m_)/2.
-   comp ones= make(nrow(des),1,1).
-   comp m_= (m_-(csum(m_&*des)/2/n)(ones,:))/n(ones,:).
-   comp cc= t(des)*sqrt(m_).
-   comp m_= n(make(1,ncol(des),1),:).
-   comp cc= (cc+t(cc))/(m_+t(m_)).
-   release m_.
   !else
-   comp cc= t(des)*m*des.
-   comp wgs= diag(cc)/2.
-   comp wgsm= wgs*make(1,ncol(des),1).
    !if (!method='BAVERAGE' !or !method='CENTROID') !then
-    comp sscpn= sscp(n).
    !else
-    comp n_n= n(make(1,ncol(des),1),:).
-    comp n_n= n_n+t(n_n).
    !ifend
    !if (!method='BAVERAGE') !then
-    comp cc= cc/sscpn.
    !else !if (!method='WAVERAGE') !then
-    comp cc= cc+wgsm+t(wgsm).
-    comp cc= cc/(n_n&*(n_n-1)/2).
    !else !if (!method='CENTROID') !then
-    comp wgsn= wgs*(n&*n).
-    comp cc= (cc-(wgsn+t(wgsn))/sscpn)/sscpn.
    !else !if (!method='WARD') !then
-    comp ssw= wgs/t(n)*make(1,ncol(des),1).
-    comp cc= 2*((cc+wgsm+t(wgsm))/n_n-(ssw+t(ssw))).
    !else !if (!method='MNSSQ') !then
-    comp cc= 2*(cc+wgsm+t(wgsm))/n_n.
    !else !if (!method='MIVAR') !then
-    comp ssw= wgs/t(n)*make(1,ncol(des),1).
-    comp cc= 4/n_n&*((cc+wgsm+t(wgsm))/n_n-(ssw+t(ssw))).
    !else !if (!method='MNVAR') !then
-    comp cc= 4/n_n&*(cc+wgsm+t(wgsm))/n_n.
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend
-   release wgsm.
   !ifend
-  comp cc= (cc+t(cc))/2.
-  call setdiag(cc,0).
  !ifend
- do if nmiss and ass=1.
   !if (!method='SINGLE' !or !method='COMPLETE' !or !method='HAUSDORFF') !then
-   comp cm= make(ncol(des),nmiss,0).
-   loop i= 1 to ncol(des).
-    comp bigval= mmax(nmm)-mmin(nmm)+1.
     !if (!method='SINGLE') !then
-     comp cm(i,:)= cmin(nmm+(not des(:,i))*make(1,nmiss,bigval)).
     !else !if (!method='COMPLETE' !or !method='HAUSDORFF') !then
-     comp cm(i,:)= cmax(nmm-(not des(:,i))*make(1,nmiss,bigval)).
     !ifend !ifend
-   end loop.
   !else
-   comp ones2= make(1,nmiss,1).
-   !if (!method='BAVERAGE' !or !method='MHAUSDORFF') !then
-    comp cm= t(des)*nmm/(t(n)*ones2).
-   !else !if (!method='WAVERAGE') !then
-    comp cm= 2*(t(des)*nmm+wgs*ones2)/(t(n&*(n+1))*ones2).
    !else !if (!method='CENTROID') !then
-    comp cm= t(des)*nmm/(t(n)*ones2)-(wgs/t(n&**2))*ones2.
    !else !if (!method='CROSSPC') !then
-    comp cm= (sqrt(t(des)*nmm/(t(n)*ones2)-(wgs/t(n&**2))*ones2)+t(des)*sqrt(nmm))/(t(n+1)*ones2).
    !else !if (!method='WARD') !then
-    comp cm= 2*((t(des)*nmm+wgs*ones2)/(t(n+1)*ones2)-wgs/t(n)*ones2).
    !else !if (!method='MNSSQ') !then
-    comp cm= 2*(t(des)*nmm+wgs*ones2)/(t(n+1)*ones2).
    !else !if (!method='MIVAR') !then /*При методе MIVAR
-    comp cm= 4/t(n+1)*ones2&*((t(des)*nmm+wgs*ones2)/(t(n+1)*ones2)-wgs/t(n)*ones2).
    !else !if (!method='MNVAR') !then
-    comp cm= 4*(t(des)*nmm+wgs*ones2)/(t(n+1)&**2*ones2).
    !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
   !ifend
   !if (!msave1<>!null !or !msave2<>!null) !then
-    comp mout= {cc,cm;t(cm),mm}.
-    comp clucodes= {t(codes);make(nrow(mcodes),1,-999)}.
-    comp idcodes= {make(ncol(codes),1,-999);mcodes}.
-    comp n= {n,make(1,nmiss,1)}.
-   else.
-    comp mout= cc.
-    comp clucodes= t(codes).
-    comp idcodes= make(ncol(codes),1,-999).
   !ifend
- end if.
  !if (!msave1<>!null !or !msave2<>!null) !then
-  do if simil.
-   comp mout= -mout.
-   call setdiag(mout,999).
-  end if.
-  comp atass= 1.
   !do !file !in (!conc(!msave1,' ',!msave2))
    !if (!file=!msave2) !then
-    do if nmiss.
-     comp atass= 2.
-    end if.
    !ifend
-   do if ass=atass.
-    save {t(n),clucodes,idcodes,mout} /out= !file /vari= col1 col2 col3 var1 to var100000.
-    print /title 'Matrix of this size is saved to external file'.
-    print nrow(mout) /title !quote(!conc(!file,':')) /space= 0.
-    do if nmiss and ass=1.
-     print /title 'New objects are at the tail of the matrix.' /space= 0.
-    end if.
-   end if.
   !doend
-  release mout.
  !ifend
- do if nmiss and ass=1.
-  comp cmmin= cmin(cm).
-  comp x= cmmin(make(1,nrow(cm),1),:).
-  comp x= t(codes(cmax(t(1:nrow(cm))*make(1,nmiss,1)&*(cm=x)))).
   !if (!save='YES') !then
-   call setdiag(cc,mmax(cc)).
-   comp y= rmin(cc).
-   call setdiag(cc,0).
-   comp ccclcl= make(nmiss,ncol(codes),0).
-   loop i= 1 to nmiss.
-    comp ccclcl(i,:)= codes=x(i).
-   end loop.
-   comp ccclcl= ccclcl*y.
   !ifend
-  comp clu= {clu;x}.
   !if (!msave2=!null) !then
-   break.
   !ifend
-  comp des= design(clu).
- comp m= {m,nmm;t(nmm),mm}.
- end if.
-end loop.
 !if (!save='YES') !then
- do if nmiss.
-  do if simil.
-   comp cmmin= -cmmin.
-   comp mmptpt= -mmptpt.
-   comp ccclcl= -ccclcl.
-  end if.
-  comp cmmin= {make(nrow(clu)-nmiss,3,-99999999.99999999);{t(cmmin),mmptpt,ccclcl}}.
- else.
-  comp cmmin= make(nrow(clu),3,-99999999.99999999).
- end if.
- save {id,t(cnam),clu,cmmin} /out= * /vari= !id varname_ !cluvar prox obob cluclu /string= varname_.
- print /title 'Cluster membership variable and its accompanying variables are saved'.
- print /title 'to a new working dataset.' /space= 0.
- do if nmiss.
-  print /title 'New objects are at the tail of the variable.' /space= 0.
- else.
-  print /title 'Varibles PROX, OBOB, CLUCLU are empty because there were no new objects.' /space= 0.
- end if.
 !ifend
 !if (!print<>'SUMM') !then
- do if nmiss.
-  print /title 'Assignment of new objects to the existent clusters:'.
-  print /title !quote(!conc(' Id - object code (by identifier ',!id,')')) /space= 0.
-  print /title !quote(!conc(' Cluster - code of cluster (by variable ',!cluvar,') to which the object was assigned')) /space= 0.
-  print {id,clu}((nrow(clu)-nmiss+1):nrow(clu),:) /title ' ' /clab= 'Id' 'Cluster' /space= 0.
- end if.
 !ifend
else.
-print /title '>!KO_ASSCLU is executed incorrectly.' /space= 0.
 !if (!save='YES') !then
- save 0 /out= *.
 !ifend
end if.
end matrix.
!do !file !in (!conc(!msave1,' ',!msave2))
-matrix.
-get m /file= !file /names= vnam.
-comp vnam= vnam(4:ncol(vnam)).
-do if all(m(:,3)=-999).
- comp n_codes= m(:,1:2).
- comp names= {'method_','rowtype_','n_',!quote(!cluvar),'varname_',vnam}.
-else.
- comp n_codes= m(:,1:3).
- comp names= {'method_','rowtype_','n_',!quote(!cluvar),!quote(!id),'varname_',vnam}.
-end if.
-save {make(nrow(m),1,!quote(!method)),make(nrow(m),1,'PROX'),n_codes,t(vnam),m(:,4:ncol(m))} /out= !file /names= names /string= method_ rowtype_ varname_.
-end matrix.
!doend
!if (!save='YES') !then
-recode prox obob cluclu (-99999999.99999999=sysmis).
-exec.
-var lev !id !cluvar (nom) /prox obob cluclu (sca).
-var lab prox 'Proximity b/w the new object and its cluster of assignment'
         obob 'Proximity b/w the new object and the nearest another new object'
         cluclu 'Proximity b/w the cluster of assignment (of the new object) and the cluster nearest to that cluster'.
!ifend
!enddefine.

*/*!KO_POINTCLUD*/vers2***************************************************************************************.
define !KO_pointclud(matrix= !charend('/') /seq= !charend('/') /id= !charend('/') /groups= !charend('/') /square= !charend('/') /method= !charend('/')
                    /self= !charend('/') /saveid= !charend('/') /print= !charend('/'))
!let !ok= 1 !let !outid= !saveid
!if (!head(!unquote(!outid))=!null) !then !let !outid= !null !ifend
!if (!method=!null !or !id=!null !or !groups=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Not specified METHOD, ID, or GROUPS.'.
!else !if (!outid<>!null !and (!method='AVER' !or !method='CENTROID')) !then !let !outid= !null
-echo ''.
-echo '>WARNING. S/c SAVEID is ignored with METHOD= AVER or CENTROID.'.
!ifend !ifend
!if (!ok) !then
-set mxloops 1E6.
-matrix.
 !let !matr= !matrix !let !fcrop= 0 !let !lcrop= 0
 !if (!substr(!matr,1,1)='?') !then !let !matr= !substr(!matr,2) !let !fcrop= 1 !ifend
 !let !lm= !len(!matr)
 !if (!substr(!matr,!lm,1)='?') !then !let !matr= !substr(!conc(' ',!matr),1,!lm) !let !lcrop= 1 !ifend
-comp ok= 1.
-get m /vari= !matr /names= cnam.
 !if (!fcrop) !then
- comp m= m(:,2:ncol(m)).
- comp cnam= cnam(:,2:ncol(cnam)). 
 !ifend
 !if (!lcrop) !then
- comp m= m(:,1:(ncol(m)-1)).
- comp cnam= cnam(:,1:(ncol(cnam)-1)).
 !ifend
-get rnam /var= varname_.
-comp rnam= t(rnam).
 !if (!seq='COL' !or !seq=!null) !then
  !let !seq1= 'cnam' !let !seq2= 'rnam' !let !rind= 'ind2' !let !cind= 'ind1'
 !else
  !let !seq1= 'rnam' !let !seq2= 'cnam' !let !rind= 'ind1' !let !cind= 'ind2'
 !ifend
-do if nrow(m)<>ncol(m).
- comp cmp= 1.
-else if any(rnam<>cnam).
- comp cmp= 1.
-else.
- comp cmp= 0.
- comp ind1= 1:ncol(m).
- comp ind2= 1:ncol(m).
-end if.
-do if cmp.
- comp flag= kroneker(t(!seq1),make(1,ncol(!seq2),1))=kroneker(!seq2,make(ncol(!seq1),1,1)).
- comp ind2= rmax((flag=1)&*(1:ncol(flag))(make(1,nrow(flag),1),:)).
- release flag.
- comp nnz= msum(ind2>0).
- do if nnz<3.
-   print /title '>ERROR. Among input matrix column names and row names there are too few'.
-   print /title '>identical to be able to compile matrix for analysis.' /space= 0.
-  comp ok= 0.
- else.
-  comp ind1= make(1,nnz,0).
-  comp cnt= 0.
-  loop i= 1 to nrow(ind2).
-   do if ind2(i).
-    comp cnt= cnt+1.
-    comp ind1(cnt)= i.
-   end if.
-  end loop.
-  comp ind2= ind2(ind1).
-  comp m= m(!rind,!cind).
-  comp cnam= cnam(!cind).
- end if.
-end if.
-do if ok.
- get id /var= !id.
- comp id= id(!rind).
- get bin /var= !groups /names= names.
- comp bin= bin(!rind,:).
- do if nrow(m)<>ncol(m).
-  print /title '>ERROR. Matrix is not square.'.
-  comp ok= 0.
- else if any(m<>t(m)).
-  print /title '>ERROR. Matrix is not symmetric.'.
-  comp ok= 0.
- else if m(1,1).
-  print /title '>ERROR. Matrix must contain distances, not similarities.'.
-  comp ok= 0.
- else if any(diag(m)<>0).
-  print /title '>ERROR. Matrix diagonal is not zero.'.
-  comp ok= 0.
- end if.
- do if ncol(bin)=1.
-  do if cmax(bin)=cmin(bin).
-   print /title '>ERROR. Variable GROUPS is a constant after compiling matrix for analysis.'.
-   comp ok= 0.
-  else.
-   comp clu= bin.
-   comp bin= design(clu).
-   comp n= csum(bin).
-   comp codes= clu*make(1,ncol(bin),1)&*bin.
-   comp codes= cmax(codes)+cmin(codes).
-   comp grd= grade(codes).
-   comp bin(:,grd)= bin.
-   comp n(grd)= n.
-   comp codes(grd)= codes.
-   release clu,grd.
-  end if.
- else.
-  comp n= csum(bin).
-  do if any(bin&*bin<>bin).
-   print /title '>ERROR. Variables GROUPS are multiple, but they are not binary.'.
-   comp ok= 0.
-  else if any(n=0).
-   print /title '>ERROR. Some binary variables GROUPS have no value 1 after compiling'.
-   print /title '>of matrix for analysis, i.e., these groups are empty.' /space= 0.
-   comp ok= 0.
-  end if.
- end if.
-end if.
-do if ok.
  !if (!square='YES') !then
-  comp m= m&*m.
  !ifend
- print /title '**** DISTANCES FROM OBJECTS TO CLUSTERS ****'.
- print nrow(id) /title 'Input was matrix of dissimilarities/distances of size:'.
  !if (!print<>'NOID') !then
-  do if cmp.
-   print /title 'Names and ID of rows/columns in the matrix compiled before the procedure'.
-   print t(id) /title !quote(!conc('(ID are values of variable ',!id,'):')) /cnam= cnam /space= 0.
-  else.
-   print /title !quote(!conc('ID of rows/columns are values of variable ',!id,'.')).
-  end if.
  !ifend
- print /title 'Information about clusters/groups.'.
- do if ncol(names)=1.
-  comp rnam= make(1,ncol(codes),'group').
-  print t({1:ncol(codes);codes;n}) /title 'Groups, their codes and frequencies:' /rnam= rnam /clab= '#' 'Code' 'Count' /space= 0.
- else.
-  print t(n) /title 'Groups (binary variables) and frequencies:' /rnam= names /clab= 'Count' /space= 0.
- end if.
- print /title !quote(!conc('Method used: ',!method)).
  !if (!method='AVER') !then
-  comp pgd= m*bin.
   !if (!self<>'OUT') !then
-   comp n= n(make(1,nrow(bin),1),:).
   !else
-   comp n= n(make(1,nrow(bin),1),:)-bin.
-   comp n= n+(not n).
   !ifend
-  comp pgd= pgd/n.
-  release m,bin,n.
  !else !if (!method='CENTROID') !then
-  comp ones= make(1,nrow(bin),1).
-  comp pgs= m*bin.
-  comp pgd= csum(pgs&*bin)/2.
   !if (!self<>'OUT') !then
-   comp pgd= (pgs-(pgd/n)(ones,:))/n(ones,:).
   !else
-   comp pgd= pgd(ones,:)-pgs&*bin.
-   comp n= n(ones,:)-bin.
-   comp n= n+(n=0).
-   comp pgd= (pgs-pgd/n)/n.
   !ifend
-  release m,bin,pgs,n,ones.
-  comp negd= pgd<0.
-  do if any(negd).
-   print /title '>WARNING. Some distances turned out negative'.
-   print /title '>(possibly, with METHOD=CENTROID you entered other distances than sq. euclidean).' /space= 0.
-   print /title '>Negative distances will be replaced by -999.' /space= 0.
-   comp pgd= pgd&*(not negd).
-  end if.
-  comp pgd= sqrt(pgd)-999*negd.
  !else !if (!method='MEDOID') !then
-  comp ones= make(nrow(bin),1,1).
-  comp pgd= m*bin.
-  comp pgd= pgd+(not bin)*1E300.
-  comp pgd= pgd=cmin(pgd)(ones,:).
-  comp ind= cmax(t(1:nrow(pgd))*make(1,ncol(pgd),1)&*pgd).
-  comp pgd= m(:,ind).
-  comp ind= t(id(ind)).
   !if (!outid<>!null) !then
-   comp ind= ind(ones,:).
   !ifend
-  release m,bin,ones.
  !else
-  comp pgd= make(nrow(bin),ncol(bin),0).
-  comp ones= make(nrow(bin),1,1).
   !if (!method='NEAR') !then
-   comp maxd1= mmax(m)+1.
-   comp m= maxd1-m.
-   call setdiag(m,0).
   !ifend
   !if (!outid<>!null) !then
-   comp ind= make(nrow(bin),ncol(bin),0).
-   comp nums= t(1:nrow(bin)).
-   comp numsm= (1:nrow(bin))(ones,:).
-   comp n_1= n=1.
    !if (!method='FARTH') !then
-    comp m= m+1.
-    call setdiag(m,0).
    !ifend
   !ifend
-  loop i= 1 to ncol(bin).
-   comp bini= bin(:,i).
-   comp dbini= m&*t(bini)(ones,:).
-   comp dneii= rmax(dbini).
-   comp pgd(:,i)= dneii.
    !if (!outid<>!null) !then
-    do if n_1(i).
-     comp ind(:,i)= make(nrow(bin),1,cmax(bini&*nums)).
-    else.
-     comp ind(:,i)= rmax((dbini=(dneii*t(ones)))&*numsm).
-    end if.
-    comp ind(:,i)= id(ind(:,i)).
    !ifend
-  end loop.
   !if (!outid<>!null) !then
-   release nums,numsm,n_1.
   !ifend
-  release m,bin,ones,dbini,dneii.
   !if (!method='NEAR') !then
-   comp pgd= maxd1&*(pgd>0)-pgd.
   !else !if (!outid<>!null) !then
-   comp pgd= pgd-(pgd>0).
   !ifend !ifend
  !ifend !ifend !ifend
  !if (!outid<>!null) !then
-  print /title 'Data with ID of neighbours (or medoids) will be saved as file or dataset'.
-  print /title !quote(!outid) /space= 0.
  !ifend
- do if ncol(names)=1.
-  save {id,pgd} /out= * /vari= !id group1 to group10000.
   !if (!outid<>!null) !then
-   save {id,ind} /out= !outid /vari= !id group1 to group10000.
   !ifend
- else.
-  comp names= {!quote(!id),names}.
-  save {id,pgd} /out= * /names= names.
   !if (!outid<>!null) !then
-   save {id,ind} /out= !outid /names= names.
   !ifend
- end if.
-else.
- save 0 /out= *.
  !if (!outid<>!null) !then
-  save 0 /out= !outid.
  !ifend
- print /title '>!KO_POINTCLUD is executed incorrectly.' /space= 0.
-end if.
-end matrix.
-var lev all (sca) /!id (nom).
!else
-exec.
-echo '>!KO_POINTCLUD is not executed.'.
!ifend
!enddefine.

*/*!KO_DENDRO*/vers3***************************************************************************************.
define !KO_dendro(sched= !charend('/') /revers= !charend('/') /label= !charend('/') /bycolor= !charend('/') /aspect= !charend('/')
              /size= !charend('/') /format= !charend('/'))
!if (!revers='NO') !then !let !rev1= 'comp sched(i,3)= rmax({sched(i,3),sched(coe,3)})' !let !rev2= 'comp sched(i,3)= rmax({sched(i,3),sched(cle,3),sched(cre,3)})' !ifend
!if (!size=!null) !then !let !sz1= 550 !let !sz2= 1000 !else !let !sz1= !head(!size) !let !sz2= !tail(!size) !ifend
set mxloops 1E6.
matrix.
print /title 'DENDROGRAM'.
get sched /file= !sched /vari= cluster1 cluster2 coef.
do if sched(1,3)>sched(nrow(sched),3).
-comp sched(:,3)= -sched(:,3).
-print /title 'Coefficients of colligation are similarities. They were converted into' /space= 0.
-print /title 'distances by sign reversal.' /space= 0.
end if.
comp max= cmax(sched(:,3)).
comp sched(:,3)= (25-1)/(max-cmin(sched(:,3)))*(sched(:,3)-max)+25.
print /title 'On the dendrogram, coefficients of colligation (distances) are' /space= 0.
print /title 'rescaled to range 1-25.' /space= 0.
loop i= 2 to nrow(sched).
- comp left= any(sched(1:(i-1),1)=sched(i,1)).
- comp right= any(sched(1:(i-1),1)=sched(i,2)).
- do if left and not right.
-  loop coe= i-1 to 1 by -1.
-  end loop if sched(coe,1)=sched(i,1).
-  !rev1.
-  do if i-coe>1.
-   comp temp= sched(i,:).
-   comp sched((coe+2):i,:)= sched((coe+1):(i-1),:).
-   comp sched(coe+1,:)= temp.
-  end if.
- else if not left and right.
-  loop coe= i-1 to 1 by -1.
-  end loop if sched(coe,1)=sched(i,2).
-  !rev1.
-  do if i-coe>1.
-   comp temp= sched(i,:).
-   comp sched((coe+2):i,:)= sched((coe+1):(i-1),:).
-   comp sched(coe+1,:)= temp.
-  end if.
- else if left and right.
-  loop cle= i-1 to 1 by -1.
-  end loop if sched(cle,1)=sched(i,1).
-  loop cre= i-1 to 1 by -1.
-  end loop if sched(cre,1)=sched(i,2).
-  !rev2.
-  do if cle<cre.
-   comp coe= cle.
-   comp cy= sched(i,2).
-  else.
-   comp coe= cre.
-   comp cy= sched(i,1).
-  end if.
-  loop cye= i-1 to coe by -1.
-  end loop if sched(cye,1)=cy.
-  loop cys= cye to coe by -1.
-   comp cy= {cy,sched(cys,2)}.
-  end loop if all(sched(cys-1,1)<>cy).
-  comp temp= {sched(cys:cye,:);sched(i,:)}.
-  do if i-cye>1.
-   comp sched((cye+2):i,:)= sched((cye+1):(i-1),:).
-  end if.
-  do if cys-coe>1.
-   comp sched(nrow(temp)+(coe+1):(cys-1),:)= sched((coe+1):(cys-1),:).
-  end if.
-  comp sched((coe+1):(coe+nrow(temp)),:)= temp.
- end if.
end loop.
release temp.
comp brax= make(nrow(sched),4,0).
comp barx= make(nrow(sched),4,0).
comp bray= {make(nrow(sched),1,0),sched(:,3),make(nrow(sched),1,0),sched(:,3)}.
comp bary= {sched(:,3),sched(:,3),sched(:,3),sched(:,3)}.
comp id= make(nrow(sched),2,0).
comp xobj= 0.
loop i= 1 to nrow(sched).
-do if not brax(i,1).
- comp brax(i,1:2)= {xobj,xobj}.
- comp barx(i,1)= xobj.
- comp id(i,1)= sched(i,1).
- comp xobj= xobj+1.
-end if.
-do if not brax(i,3).
- comp brax(i,3:4)= {xobj,xobj}.
- comp barx(i,3)= xobj.
- comp id(i,2)= sched(i,2).
- comp xobj= xobj+1.
-end if.
-comp xmid= (barx(i,1)+barx(i,3))/2.
-comp barx(i,{2,4})= {xmid,xmid}.
-loop j= i+1 to nrow(sched).
- do if sched(j,1)=sched(i,1).
-  comp brax(j,1:2)= {xmid,xmid}.
-  comp barx(j,1)= xmid.
-  comp bray(j,1)= sched(i,3).
-  break.
- else if sched(j,2)=sched(i,1).
-  comp brax(j,3:4)= {xmid,xmid}.
-  comp barx(j,3)= xmid.
-  comp bray(j,3)= sched(i,3).
-  break.
- end if.
-end loop.
end loop.
comp brax= reshape(brax,nrow(sched)*2,2).
comp bray= reshape(bray,nrow(sched)*2,2).
comp barx= reshape(barx,nrow(sched)*2,2).
comp bary= reshape(bary,nrow(sched)*2,2).
comp id= reshape(id,nrow(sched)*2,1).
save {brax,bray,id;barx,bary,make(nrow(sched)*2,1,0)} /outfile= * /vari= xfrom#$ xto#$ yfrom#$ yto#$ id.
end matrix.
recode id (0=sysmis).
!if (!aspect='GRAPE') !then
-if yfrom#$=0 and yto#$>1 yfrom#$= yto#$-1.
!ifend
exec.
format id (!if (!format=!null) !then f8 !else !format !ifend).
var lev xfrom#$ xto#$ id (nom) yfrom#$ yto#$ (sca).
!if (!label<>!null) !then !let !lab= !head(!tail(!label))
-sort cases by id.
-match files /file= * /table= !head(!label) /by id.
-exec.
!else !let !lab= 'id'
!ifend
!if (!bycolor=!null) !then
-do if $casenum=1.
- write outfile= 'temp_KO_dendro.sps'
   /'SOURCE: s= userSource(id("graphdataset"))'
   /'DATA: xfrom= col(source(s),name("xfrom#$"))'
   /'DATA: yfrom= col(source(s),name("yfrom#$"))'
   /'DATA: xto= col(source(s),name("xto#$"))'
   /'DATA: yto= col(source(s),name("yto#$"))'
   /!quote(!conc('DATA: lab= col(source(s),name("',!lab,'"),unit.category())'))
   /!quote(!conc('PAGE: begin(scale(',!sz1,',',!sz2,'))'))
   /'GUIDE: axis(dim(1),ticks(null()))'
   /'GUIDE: axis(dim(2),label("Rescaled Distance Cluster Combine"),opposite())'
   /'COORD: transpose(reflect(dim(1)))'
   /'ELEMENT: edge(position((xfrom*yfrom)+(xto*yto)),shape(shape.line),size(size."1"))'
   /'ELEMENT: point(position((xfrom*yfrom)),label(lab,showAll()),size(size."0"))'
   /'PAGE: end()'.
-end if.
!else !let !clr= !head(!tail(!bycolor))
-sort cases by id.
-match files /file= * /table= !head(!bycolor) /by id.
-var lev !clr (nom).
-do if $casenum=1.
- write outfile= 'temp_KO_dendro.sps'
   /'SOURCE: s= userSource(id("graphdataset"))'
   /'DATA: xfrom= col(source(s),name("xfrom#$"))'
   /'DATA: yfrom= col(source(s),name("yfrom#$"))'
   /'DATA: xto= col(source(s),name("xto#$"))'
   /'DATA: yto= col(source(s),name("yto#$"))'
   /!quote(!conc('DATA: lab= col(source(s),name("',!lab,'"),unit.category())'))
   /!quote(!conc('DATA: color= col(source(s),name("',!clr,'"),unit.category())'))
   /!quote(!conc('PAGE: begin(scale(',!sz1,',',!sz2,'))'))
   /'GUIDE: axis(dim(1),ticks(null()))'
   /'GUIDE: axis(dim(2),label("Rescaled Distance Cluster Combine"),opposite())'
   /!quote(!conc('GUIDE: legend(aesthetic(aesthetic.color.interior),label("',!clr,'"))'))
   /'COORD: transpose(reflect(dim(1)))'
   /'ELEMENT: edge(position((xfrom*yfrom)+(xto*yto)),shape(shape.line),size(size."1"),color.interior(color))'
   /'ELEMENT: point(position((xfrom*yfrom)),label(lab,showAll()),size(size."0"))'
   /'PAGE: end()'.
-end if.
!ifend
cache.
exec.
GGRAPH
 /GRAPHDATASET NAME= "graphdataset" VARIABLES= xfrom#$ yfrom#$ xto#$ yto#$ !lab !clr MISSING= VARIABLEWISE
 /GRAPHSPEC SOURCE= GPLFILE('temp_KO_dendro.sps').
!if (!bycolor=!null !and !label=!null) !then
-select if not sysmis(id).
-match files /file= * /rename (yto#$=mergelev) /keep id mergelev.
-exec.
-var lab id 'Item' mergelev 'Level of merge on the dendrogram'.
!else
-new file.
!ifend
erase file 'temp_KO_dendro.sps'.
!enddefine.

*/*!KO_KMINI*/vers1***************************************************************************************.
define !KO_kmini(vars= !charend('/') /id= !charend('/') /k= !charend('/') /method= !charend('/') /outfile= !charend('/') /print= !charend('/'))
!if (!print='NO' !and !outfile=!null) !then
-echo '>ERROR. OUTFILE is not specified and PRINT=NO: !KO_KMINI is not run.'.
!else
-set mxloops 1E9.
 !if (!method='WARD') !then
- matrix.
- get data /vari= !vars /miss= omit /names= cnam.
- print /title '**** INITIALIZING CENTERS FOR K-MEANS ****'.
- print {nrow(data),!k} /title 'Number of valid cases in the data read and the requested K:'.
- do if !k>=nrow(data) or !k<2.
-  print /title '>ERROR. K must be less than the number of data cases and greater than 1.'.
-  print /title '>!KO_KMINI is executed incorrectly.' /space= 0.
   !if (!outfile<>!null) !then
-   save 0 /out= !outfile.
   !ifend
- else.
-  save data /out= * /names= cnam.
-  print /title 'Method: WARD'.
- end if.
- end matrix.
- set results none errors none.
- cluster !vars
   /method= ward (clu.#) /measure= seuclid /plots= none /print= none /save cluster(!k).
- set results list errors list.
- rename var (!conc('clu.#',!k)=cluster_).
- aggreg /outfile= * /break= cluster_
   /!vars= mean(!vars).
  !if (!print='YES' !or !print=!null) !then
-  format !vars (f8.4).
-  echo 'Initial centers:'.
-  list !vars.
  !ifend
  !if (!outfile<>'*') !then
   !if (!outfile<>!null) !then
-   save outfile !outfile.
   !ifend
-  new file.
  !ifend
 !else
- matrix.
- get data /vari= !id !vars /miss= omit /names= cnam.
  !if (!id<>!null) !then
-  comp id= data(:,1).
-  comp data= data(:,2:ncol(data)).
  !ifend
- print /title '**** INITIALIZING CENTERS FOR K-MEANS ****'.
- print {nrow(data),!k} /title 'Number of valid cases in the data read and the requested K:'.
- do if !k>=nrow(data) or !k<2.
-  print /title '>ERROR. K must be less than the number of data cases and greater than 1.'.
-  print /title '>!KO_KMINI is executed incorrectly.' /space= 0.
-  comp ok= 0.
- else.
-  comp ok= 1.
-  comp k= !k.
-  print /title !quote(!conc('Method: ',!method)).
-  comp nones= make(nrow(data),1,1).
-  comp nnums= t(1:nrow(data)).
   !if (!method='RGC') !then
-   comp gr= trunc(uniform(nrow(data),1)*k)+1.
-   comp gr= design(gr).
-   comp ini= t(gr)*data/(t(csum(gr))*make(1,ncol(data),1)).
   !else !if (!method='RP') !then
-   comp g= 0.
-   comp ind= trunc(uniform(k,1)*nrow(nones))+1.
-   loop i= 1 to k.
-    do if nones(ind(i)).
-     comp nones(ind(i))= 0.
-    else.
-     loop g= 1 to 1E9.
-      comp val= trunc(uniform(1,1)*nrow(nones))+1.
-     end loop if nones(val).
-     comp ind(i)= val.
-     comp nones(val)= 0.
-    end if.
-   end loop.
   !else !if (!method='RUNFP') !then
-   comp kones= make(k,1,1).
-   comp knums= t(1:k).
-   comp ini= data(1:k,:).
-   comp ind= knums.
-   comp d= sscp(t(ini)). 
-   comp bigval= diag(d)*make(1,ncol(d),1).
-   comp d= bigval+t(bigval)-2*d. 
-   comp bigval= 1E300.
-   call setdiag(d,bigval).
-   comp cr= 0.
-   loop i= k+1 to nrow(data).
-    comp casei= data(i,:).
-    comp diini= rssq(casei(kones,:)-ini).
-    comp bigval= rmax({bigval,cmax(diini)+1}).
-    comp min= cmin(diini).
-    comp c= cmax((diini=min)&*knums).
-    comp mind= mmin(d).
-    do if min>mind.
-     comp diini2= diini+rmin(d<>mind)*bigval.
-     comp cr= cmax((cmin(diini2)=diini)&*knums).
-    else.
-     comp diini(c)= bigval.
-     comp min= cmin(diini).
-     do if min>rmin(d(c,:)).
-      comp cr= c.
-     end if.
-    end if.
-    do if cr.
-     comp ini(cr,:)= casei.
-     comp ind(cr)= i. 
-     comp d(cr,:)= t(diini).
-     comp d(:,cr)= diini.
-     call setdiag(d,bigval).
-     comp cr= 0.
-    end if.
-   end loop.
   !else !if (!method='SIMFP') !then
-   comp ind= trunc(uniform(1,1)*nrow(data))+1.
-   comp dc= make(nrow(data),k-1,0).
-   loop i= 1 to k-1.
-    comp dc(:,i)= rssq(data-data(ind(i),:)(nones,:)).
-    comp mindc= rmin(dc(:,1:i)).
-    comp mindc(ind)= make(nrow(ind),1,0).
-    comp c= cmax((mindc=cmax(mindc))&*nnums).
-    comp ind= {ind;c}.
-   end loop.
   !else !if (!method='KMPP') !then
-   comp ind= trunc(uniform(1,1)*nrow(data))+1.
-   comp dc= make(nrow(data),k-1,0).
-   comp rand= uniform(1,k-1).
-   loop i= 1 to k-1.
-    comp dc(:,i)= rssq(data-data(ind(i),:)(nones,:)).
-    comp mindc= rmin(dc(:,1:i)).
-    comp mindc(ind)= make(nrow(ind),1,0).
-    comp mindc= mindc/csum(mindc).
-    comp randi= rand(i).
-    comp cump= 0.
-    loop c= 1 to nrow(mindc).
-     comp cump= cump+mindc(c).
-    end loop if randi<=cump.
-    comp ind= {ind;c}.
-   end loop.
   !else !if (!method='GREP') !then
-   comp dc= rssq(data-(csum(data)/nrow(data))(nones,:)).
-   comp ind= cmax((dc=cmin(dc))&*nnums).
-   comp d= sscp(t(data)). 
-   comp hsq= diag(d)*make(1,ncol(d),1). 
-   comp d= hsq+t(hsq)-2*d. 
-   release hsq.
-   comp dc= d(ind,:).
-   call setdiag(d,1E300).
-   loop i= 1 to k-1.
-    comp g= dc(nones,:)-d.
-    comp g= rsum(g&*(g>0)).
-    comp maxg= cmax(g).
-    do if not maxg.
-     print /title '>ERROR. Impossible to select k cases as distinct centers (method GREP).'.
-     print /title '>!KO_KMINI is executed incorrectly.' /space= 0.
-     comp ok= 0.
-     break.
-    end if.
-    comp c= cmax((g=maxg)&*nnums).
-    comp ind= {ind;c}.
-    comp dc= cmin({dc;d(c,:)}).
-    comp dc(c)= 0.
-   end loop.
   !ifend !ifend !ifend !ifend !ifend !ifend
- end if.
- do if ok.
   !if (!method<>'RGC') !then
-   comp ini= data(ind,:).
   !ifend
-  loop i= 1 to nrow(ini)-1.
-   loop j= i+1 to nrow(ini).
-   end loop if all(ini(i,:)=ini(j,:)).
-   do if j<=nrow(ini).
-    print /title '>WARNING. Some initial centers coincide by their coordinates;'.
-    print /title '>perhaps the centers should not be used.' /space= 0.
-    break.
-   end if.
-  end loop.
   !if (!print<>'NO') !then
    !if (!id<>!null !and !method<>'RGC') !then
-    print {id(ind),ini} /title= 'Initial centers:' /cnam= cnam /format= f8.4.
    !else
     !if (!id<>!null) !then
-     comp cnam2= cnam(2:ncol(cnam)).
-    !else
-     comp cnam2= cnam.
     !ifend
-    print ini /title= 'Initial centers:' /cnam= cnam2 /format= f8.4.
    !ifend
   !ifend
   !if (!outfile<>!null) !then
    !if (!id=!null) !then
-    comp cnam= {'cluster_',cnam}.
    !else
-    comp cnam(1)= 'cluster_'.
    !ifend
-   save {t(1:k),ini} /out= !outfile /names= cnam.
-   print /title !quote(!conc('Initial centers were saved as file/dataset: ',!outfile,'.')).
   !ifend
- else.
   !if (!outfile<>!null) !then
-   save 0 /out= !outfile.
   !ifend
- end if.
- end matrix.
 !ifend
!ifend
!enddefine.
